<template>
    <div class="editor-container">
        <div v-if="error" class="bad">
            <span>
               {{error}}
                <ul>
                    <li v-bind:key="key" v-for="{ key, name } in badFields">{{name}}</li>
                </ul>
            </span>
        </div>
        <Field
                v-bind:key="field.key"
                v-for="field in fields"
                :field="field"
                :values="value"
                @edited="edited"
        />
    </div>
</template>
<script>
  import Vue from 'vue';

  import { MdField } from 'vue-material/dist/components';
  import Field from './Field';

  Vue.use(MdField);

  export default {
    props: {
      value: {
        type: Object,
        isRequired: true
      },
      fields: {
        type: Array,
        isRequired: true
      }
    },
    data(){
      return {
        error: undefined
      }
    },
    computed: {
      badFields() {
        const bad = [];
        console.log('bad start');
        this.fields.forEach(({ key, required, label }) => {
          if (required) {
            const content = this.value[key];
            if (!content || content.trim().length === 0) bad.push({key, name: label});
          }
        });
        return bad;
      },
      hasBadFields() {
        return this.badFields.length > 0;
      }
    },
    methods: {
      edited({ key, value }) {
        this.error = undefined;
        this.value[key] = value;
        this.$emit('input', this.value);
      },
      /****************** error API **********************************/
      checkFields(){
        this.error = this.hasBadFields && this.$t('editor.correctFields');
        return !this.error;
      },
      showError(msg){
        this.error = msg;
        this.$forceUpdate();
      }
      /*************************************************************/
    },
    components: {
      Field
    }
  };
</script>
<style scoped>
    .editor-container {

    }

    .bad {
        color: var(--md-theme-default-fieldvariant);
        padding: 4px;
        border: 1px solid var(--md-theme-default-fieldvariant);
    }
</style>
